# -*- coding: utf-8 -*-
"takes care of the option's values"
# Copyright (C) 2012 Team tiramisu (see AUTHORS for all contributors)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# The original `Config` design model is unproudly borrowed from
# the rough pypy's guys: http://codespeak.net/svn/pypy/dist/pypy/config/
# the whole pypy projet is under MIT licence
# ____________________________________________________________

class OptionValues(object):
    def __init__(self):
        self.owners = {}
        "Config's root indeed is in charge of the `Option()`'s values"
        self.values = {}
        self.previous_values = {}

    def __getitem__(self, opt_or_descr):
        return self.values[opt_or_descr]

    def __setitem__(self, opt_or_descr, value):
        self.values[opt_or_descr] = value

    def __contains__(self, opt_or_descr):
        return opt_or_descr in self.values
